//+------------------------------------------------------------------+ 
//| HMA.mq4 
//| Copyright  2006 WizardSerg <wizardserg@mail.ru>, ?? ??????? ForexMagazine #104 
//| wizardserg@mail.ru 
//| Revised by IgorAD,igorad2003@yahoo.co.uk |   
//| Personalized by iGoR AKA FXiGoR for the Trend Slope Trading method (T_S_T) 
//| Link: 
//| contact: thefuturemaster@hotmail.com         
//| 
//| ++ modifications to add speech and PlaySound by hapalkos  2007.01.25                                                                
//+------------------------------------------------------------------+
#property copyright "MT4 release WizardSerg <wizardserg@mail.ru>, ?? ??????? ForexMagazine #104" 
#property link      "wizardserg@mail.ru"

#include <gSpeak.mqh>      // NOTE 1 ...  Reference to gSpeak.mqh which must be installed in the "include" directory.
                           // NOTE 1 ...  The operating system module, speak.dll, must also be installed in the "library" directory.
                           // NOTE 1 ...  These two modules access the currently selected text-to-speech engine of your computer.  

#property indicator_chart_window 
#property indicator_buffers 3 
#property indicator_color2 Blue 
#property indicator_color3 Red 
#property indicator_color1 Orange 
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1

//---- input parameters 
extern int       period=20; 
extern int       method=1;                         // MODE_SMA 
extern int       price=0;                          // PRICE_CLOSE
extern int       EmailON=1;                        // 0 = false    1 = true
extern int       SoundON=1;                        // 0 = false    1 = true
extern int       SpeechON=0;                       // 0 = false    1 = true      NOTE 5 ... Switch for turning speech on and off.
extern int       PlaySoundON=1;                    // 0 = false    1 = true      NOTE 6 ... Switch for turning PlaySound on and off.                   
//---- buffers 
double Uptrend[];
double Dntrend[];
double ExtMapBuffer[]; 
double buff[];

string FinSym;             // NOTE 2 ...  addition of FinSym (Financial Symbol) to facilitate the use of Symbol() for speech.
string ChartPeriod;        // NOTE 2 ...  addition of ChartPeriod to facillitate the use of Period() for speech.

string AlertWav1="falling-price-alert.wav";     // NOTE 6 ...  String for PlaySound.
string AlertWav2="rising-price-alert.wav";      // NOTE 6 ...  String for PlaySound.
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
{ 
    IndicatorBuffers(3);  
    SetIndexBuffer(1, Uptrend); 
    //ArraySetAsSeries(Uptrend, true); 
    SetIndexBuffer(2, Dntrend); 
    //ArraySetAsSeries(Dntrend, true); 
    //SetIndexBuffer(2, ExtMapBuffer); 
    //ArraySetAsSeries(Uptrend, true);
    SetIndexBuffer(0, ExtMapBuffer); 
    ArraySetAsSeries(ExtMapBuffer, true); 
    
    SetIndexStyle(0,DRAW_LINE);
    SetIndexStyle(1,DRAW_LINE);
    SetIndexStyle(2,DRAW_LINE);
    
    IndicatorShortName("Slope Direction Line("+period+")"); 
    return(0); 
} 

//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
{ 
    // ???? ????? ?????? ?????? 
    return(0); 
} 

//+------------------------------------------------------------------+ 
//| ?????????? ???????                                               | 
//+------------------------------------------------------------------+ 
double WMA(int x, int p) 
{ 
    return(iMA(NULL, 0, p, 0, method, price, x));    
} 

//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
{ 
    int counted_bars = IndicatorCounted(); 
    
    if(counted_bars < 0) 
        return(-1); 
                  
    int x = 0; 
    int p = MathSqrt(period);              
    int e = Bars - counted_bars + period + 1; 
    
    double vect[], trend[]; 
    
    if(e > Bars) 
        e = Bars;    

    ArrayResize(vect, e); 
    ArraySetAsSeries(vect, true);
    ArrayResize(trend, e); 
    ArraySetAsSeries(trend, true); 
    
    for(x = 0; x < e; x++) 
    { 
        vect[x] = 2*WMA(x, period/2) - WMA(x, period);        
 //       Print("Bar date/time: ", TimeToStr(Time[x]), " close: ", Close[x], " vect[", x, "] = ", vect[x], " 2*WMA(p/2) = ", 2*WMA(x, period/2), " WMA(p) = ",  WMA(x, period)); 
    } 

    for(x = 0; x < e-period; x++)
     
        ExtMapBuffer[x] = iMAOnArray(vect, 0, p, 0, method, x);        
    
    for(x = e-period; x >= 0; x--)
    {     
        trend[x] = trend[x+1];
        if (ExtMapBuffer[x]> ExtMapBuffer[x+1]) trend[x] =1;
        if (ExtMapBuffer[x]< ExtMapBuffer[x+1]) trend[x] =-1;
    
    if (trend[x]>0)
    { Uptrend[x] = ExtMapBuffer[x]; 
      if (trend[x+1]<0) Uptrend[x+1]=ExtMapBuffer[x+1];
      Dntrend[x] = EMPTY_VALUE;
    }
    else              
    if (trend[x]<0)
    { 
      Dntrend[x] = ExtMapBuffer[x]; 
      if (trend[x+1]>0) Dntrend[x+1]=ExtMapBuffer[x+1];
      Uptrend[x] = EMPTY_VALUE;
    }    
    buff[x] = trend[x];          

//+------------------------------------------------------------------+ 
//| Begin additions to facilitate speech                             | 
//+------------------------------------------------------------------+ 

      if (Symbol() == "GBPUSD") FinSym = "Kay bull";        // NOTE 3 ...  Provides pronunciation for the Symbol() of the chart. 
      if (Symbol() == "EURUSD") FinSym = "euro dollar";     // NOTE 3 ...  Spelling may need to be altered to achieve correct pronunciation with your speech engine.
      if (Symbol() == "AUDUSD") FinSym = "aussie dollar";   // NOTE 3 ...  Additional pairs can be added in the same manner.
      if (Symbol() == "USDJPY") FinSym = "doll are yen";
      if (Symbol() == "USDCAD") FinSym = "loonie";
      if (Symbol() == "USDCHF") FinSym = "swissie";
      
      if (Period() == 1) ChartPeriod = " one min it ";      // NOTE 3 ...  Provides pronunciation for the Period() of the chart.
      if (Period() == 5) ChartPeriod = " five min it ";     // NOTE 3 ...  Spelling may need to be altered to achieve correct pronunciation with your speech engine.
      if (Period() == 15) ChartPeriod = " fifteen min it ";
      if (Period() == 30) ChartPeriod = " thirty min it ";
      if (Period() == 60) ChartPeriod = " one hour ";
      if (Period() == 240) ChartPeriod = " four hour ";
      if (Period() == 1440) ChartPeriod = " daily ";
      if (Period() == 10080) ChartPeriod = " weekly ";
      if (Period() == 43200) ChartPeriod = " monthly ";
                                                         
      string CurrentBid = DoubleToStr(Bid, Digits);    // NOTE 4 ...  CurrentBid price using the DoubleToStr command to limit the number of spoken digits. 
      string CurrentAsk = DoubleToStr(Ask, Digits);    // NOTE 4 ...  CurrentAsk price using the DoubleToStr command to limit the number of spoken digits.

//+------------------------------------------------------------------+ 
//| End additions to facilitate speech                               | 
//+------------------------------------------------------------------+ 
    
    //Print( " trend=",trend[x]);
    }
    if (EmailON==1 && Dntrend[0] != EMPTY_VALUE &&   Dntrend[1] == EMPTY_VALUE && isNewBar())
    { 
      if (SoundON==1) Alert("SELL signal at Ask=",Ask,", Bid=",Bid,", Date=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period());
      if (SpeechON==1) gSpeak(" SELL signal! " + " SELL signal! " + ChartPeriod + FinSym + CurrentBid );   // NOTE 5 ...  qSpeak function added so that activates with the Alert.
      if (PlaySoundON==1) PlaySound(AlertWav1);                                                            // NOTE 6 ...  PlaySound function added so that .wav files can be played.
      SendMail("SELL signal alert","SELL signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
    }
    if (EmailON==1 && Uptrend[0] != EMPTY_VALUE &&   Uptrend[1] == EMPTY_VALUE && isNewBar()) 
    { 
      if (SoundON==1) Alert("BUY signal at Ask=",Ask,", Bid=",Bid,", Time=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period());
      if (SpeechON==1) gSpeak(" BUY signal! " + " BUY signal! " + ChartPeriod + FinSym + CurrentAsk );     // NOTE 5 ...  qSpeak function added so that activates with the Alert.
      if (PlaySoundON==1) PlaySound(AlertWav2);                                                            // NOTE 6 ...  PlaySound function added so that .wav files can be played.
      SendMail("BUY signal alert","BUY signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
    }
    return(0); 
}

bool isNewBar()
{
   static datetime lastbar=0;
   datetime curbar = Time[0];
   if(lastbar!=curbar)
   {
      lastbar=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}  

 
//+------------------------------------------------------------------+ 

